;--------------------------------
;Include MUI
; https://nsis.sourceforge.io/Docs/Modern%20UI%202/Readme.html

  !include "MUI2.nsh"

;--------------------------------
;Parameters
!define APPNAME "Micro Kernel"
!define COMPANYNAME "Cerbelle"
!define DESCRIPTION "MicroKernel amazing modular application"
# These three must be integers
!define VERSIONMAJOR 0
!define VERSIONMINOR 0
!define VERSIONBUILD 1
# These will be displayed by the "Click here for support information" link in "Add/Remove Programs"
# It is possible to use "mailto:" links in here to open the email client
!define HELPURL "https://redmine.cerbelle.net/projects/mkernel/wiki" # "Support Information" link
!define UPDATEURL "https://redmine.cerbelle.net/projects/mkernel/activity" # "Product Updates" link
!define ABOUTURL "https://redmine.cerbelle.net/projects/mkernel" # "Publisher" link
# This is the size (in kB) of all the files copied into "Program Files"
!define INSTALLSIZE 3880

;--------------------------------
;General

  ;Name and file
  Name "${COMPANYNAME} - ${APPNAME}"
  OutFile "mkernel-installer.exe"
  Unicode True

  ;Default installation folder
  InstallDir "$LOCALAPPDATA\${COMPANYNAME}\${APPNAME}"

  ;Get installation folder from registry if available
  InstallDirRegKey HKCU "Software\${COMPANYNAME} - ${APPNAME}" ""

  ;Request application privileges for Windows Vista
  RequestExecutionLevel user

  # Removing 'Nullsoft Install System vX.XX' String from installer
  BrandingText "${COMPANYNAME}"

;--------------------------------
;Variables
;
  Var StartMenuFolder

;--------------------------------
;Interface Settings

  ;!define MUI_ICON "${TOPBUILDDIR}/wininst/usr/share/icons/hicolor/scalable/apps/mkernel.ico"
  ;!define MUI_UNICON "${TOPBUILDDIR}/wininst/usr/share/icons/hicolor/scalable/apps/mkernel.ico"
  !define MUI_ABORTWARNING

  ;!define MUI_LANGDLL_WINDOWTITLE text
  ;!define MUI_LANGDLL_INFO text
  ;!define MUI_LANGDLL_ALWAYSSHOW
  !define MUI_LANGDLL_ALLLANGUAGES

;--------------------------------
;Language Selection Dialog Settings

  ;Remember the installer language
  !define MUI_LANGDLL_REGISTRY_ROOT "HKCU"
  !define MUI_LANGDLL_REGISTRY_KEY "Software\${COMPANYNAME} - ${APPNAME}"
  !define MUI_LANGDLL_REGISTRY_VALUENAME "Installer Language"

;--------------------------------
;Welcome page settings
  ;!define MUI_WELCOMEPAGE_TITLE title
  ;!define MUI_WELCOMEPAGE_TITLE_3LINES
  ;!define MUI_WELCOMEPAGE_TEXT text

;--------------------------------
;License page settings
  ;!define MUI_LICENSEPAGE_TEXT_TOP text
  ;!define MUI_LICENSEPAGE_TEXT_BOTTOM text
  ;!define MUI_LICENSEPAGE_BUTTON button_text
  ;!define MUI_LICENSEPAGE_CHECKBOX
  ;!define MUI_LICENSEPAGE_CHECKBOX_TEXT text
  ;!define MUI_LICENSEPAGE_RADIOBUTTONS
  ;!define MUI_LICENSEPAGE_RADIOBUTTONS_TEXT_ACCEPT text
  ;!define MUI_LICENSEPAGE_RADIOBUTTONS_TEXT_DECLINE text

;--------------------------------
;Components page settings
  ;!define MUI_COMPONENTSPAGE_TEXT_TOP text
  ;!define MUI_COMPONENTSPAGE_TEXT_COMPLIST text
  ;!define MUI_COMPONENTSPAGE_TEXT_INSTTYPE text
  ;!define MUI_COMPONENTSPAGE_TEXT_DESCRIPTION_TITLE text
  ;!define MUI_COMPONENTSPAGE_TEXT_DESCRIPTION_INFO text

;--------------------------------
;Directory page settings
  ;!define MUI_DIRECTORYPAGE_TEXT_TOP text
  ;!define MUI_DIRECTORYPAGE_TEXT_DESTINATION text
  ;!define MUI_DIRECTORYPAGE_VARIABLE variable
  ;!define MUI_DIRECTORYPAGE_VERIFYONLEAVE

;--------------------------------
;StartMenu folder page settings
  ;!define MUI_STARTMENUPAGE_TEXT_TOP text
  ;!define MUI_STARTMENUPAGE_TEXT_CHECKBOX text
  !define MUI_STARTMENUPAGE_DEFAULTFOLDER "${COMPANYNAME}"
  !define MUI_STARTMENUPAGE_NODISABLE
  !define MUI_STARTMENUPAGE_REGISTRY_ROOT "HKCU"
  !define MUI_STARTMENUPAGE_REGISTRY_KEY "Software/${COMPANYNAME} - ${APPNAME}"
  !define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "StartMenuFolder"

;--------------------------------
;Installation page settings
  ;!define MUI_INSTFILESPAGE_FINISHHEADER_TEXT text
  ;!define MUI_INSTFILESPAGE_FINISHHEADER_SUBTEXT text
  ;!define MUI_INSTFILESPAGE_ABORTHEADER_TEXT text
  ;!define MUI_INSTFILESPAGE_ABORTHEADER_SUBTEXT text

;--------------------------------
;Finish page settings
  ;!define MUI_FINISHPAGE_TITLE title
  ;!define MUI_FINISHPAGE_TITLE_3LINES
  ;!define MUI_FINISHPAGE_TEXT text
  ;!define MUI_FINISHPAGE_TEXT_LARGE
  ;!define MUI_FINISHPAGE_BUTTON text
  !define MUI_FINISHPAGE_CANCEL_ENABLED
  ;!define MUI_FINISHPAGE_TEXT_REBOOT text
  ;!define MUI_FINISHPAGE_TEXT_REBOOTNOW text
  ;!define MUI_FINISHPAGE_TEXT_REBOOTLATER text
  ;!define MUI_FINISHPAGE_REBOOTLATER_DEFAULT
  ;!define MUI_FINISHPAGE_RUN exe_file
  ;!define MUI_FINISHPAGE_RUN_TEXT text
  ;!define MUI_FINISHPAGE_RUN_PARAMETERS parameters
  ;!define MUI_FINISHPAGE_RUN_NOTCHECKED
  ;!define MUI_FINISHPAGE_RUN_FUNCTION function
  !define MUI_FINISHPAGE_SHOWREADME "${INSTDIR}/README"
  ;!define MUI_FINISHPAGE_SHOWREADME_TEXT text
  !define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED
  ;!define MUI_FINISHPAGE_SHOWREADME_FUNCTION function
  ;!define MUI_FINISHPAGE_LINK link_text
  !define MUI_FINISHPAGE_LINK_LOCATION "{ABOUTURL}"
  ;!define MUI_FINISHPAGE_LINK_COLOR (color: RRGGBB hexadecimal)
  ;!define MUI_FINISHPAGE_NOREBOOTSUPPORT

;--------------------------------
;Uninstall confirm page settings
  ;!define MUI_UNCONFIRMPAGE_TEXT_TOP text
  ;!define MUI_UNCONFIRMPAGE_TEXT_LOCATION text
  ;!define MUI_UNCONFIRMPAGE_VARIABLE variable

;--------------------------------
;Pages

  !insertmacro MUI_PAGE_WELCOME
  !insertmacro MUI_PAGE_LICENSE "${TOPSRCDIR}/README"
  !insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_STARTMENU Application $StartMenuFolder
  !insertmacro MUI_PAGE_INSTFILES
  !insertmacro MUI_PAGE_FINISH

  ;!insertmacro MUI_UNPAGE_WELCOME
  !insertmacro MUI_UNPAGE_CONFIRM
  ;!insertmacro MUI_UNPAGE_LICENSE "${TOPSRCDIR}/README"
  ;!insertmacro MUI_UNPAGE_COMPONENTS
  ;!insertmacro MUI_UNPAGE_DIRECTORY
  !insertmacro MUI_UNPAGE_INSTFILES
  ;!insertmacro MUI_UNPAGE_FINISH

;--------------------------------
;Languages

  !insertmacro MUI_LANGUAGE "English" ; The first language is the default language
  !insertmacro MUI_LANGUAGE "French"

;--------------------------------
;Reserve Files

  !insertmacro MUI_RESERVEFILE_LANGDLL

;--------------------------------
;Installer Sections

LangString DESC_SecCore ${LANG_ENGLISH} "Micro Kernel's core."
LangString DESC_SecCore ${LANG_FRENCH}  "Cœur de Micro Kernel."
Section "MKernel" SecCore
  ;Store installation folder
  WriteRegStr HKCU "Software\${COMPANYNAME} - ${APPNAME}" "" $INSTDIR

  SetOutPath "$INSTDIR"
  File "${TOPBUILDDIR}/wininst/usr/bin/mkernel/*"
  File "${TOPBUILDDIR}/wininst/usr/share/doc/mkernel/*"
;  File "${TOPBUILDDIR}/wininst/usr/share/locale/"
  File "${TOPBUILDDIR}/wininst/usr/share/icons/hicolor/scalable/apps/mkernel.ico"

  ;create desktop shortcut
  CreateShortCut "$DESKTOP\${APPNAME}.lnk" "$INSTDIR\mkernel.exe"
  CreateShortCut "$DESKTOP\${APPNAME}-aaa.lnk" "$INSTDIR\mkernel.exe" "aaa"
  CreateShortCut "$DESKTOP\${APPNAME}-uninst.lnk" "$INSTDIR\uninstall.exe" ""

  ;Start Menu
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
    createDirectory "$SMPROGRAMS\$StartMenuFolder"
    createShortCut "$SMPROGRAMS\$StartMenuFolder\${APPNAME}.lnk" "$INSTDIR\mkernel.exe"
    createShortCut "$SMPROGRAMS\$StartMenuFolder\${APPNAME}-aaa.lnk" "$INSTDIR\mkernel.exe" "aaa"
  !insertmacro MUI_STARTMENU_WRITE_END

  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

  # Registry information for add/remove programs
  WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "DisplayName" "${COMPANYNAME} - ${APPNAME} - ${DESCRIPTION}"
  WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "UninstallString" "$\"$INSTDIR\Uninstall.exe$\""
  WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "QuietUninstallString" "$\"$INSTDIR\Uninstall.exe$\" /S"
  WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "InstallLocation" "$\"$INSTDIR$\""
  WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "DisplayIcon" "$\"$INSTDIR\mkernel.ico$\""
  WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "Publisher" "$\"${COMPANYNAME}$\""
  WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "HelpLink" "$\"${HELPURL}$\""
  WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "URLUpdateInfo" "$\"${UPDATEURL}$\""
  WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "URLInfoAbout" "$\"${ABOUTURL}$\""
  WriteRegStr HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "DisplayVersion" "$\"${VERSIONMAJOR}.${VERSIONMINOR}.${VERSIONBUILD}$\""
  WriteRegDWORD HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "VersionMajor" ${VERSIONMAJOR}
  WriteRegDWORD HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "VersionMinor" ${VERSIONMINOR}
  # There is no option for modifying or repairing the install
  WriteRegDWORD HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "NoModify" 1
  WriteRegDWORD HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "NoRepair" 1
  # Set the INSTALLSIZE constant (!defined at the top of this script) so Add/Remove Programs can accurately report the size
  WriteRegDWORD HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}" "EstimatedSize" ${INSTALLSIZE}
SectionEnd

LangString DESC_SecMkModTTY ${LANG_ENGLISH} "Sample module."
LangString DESC_SecMkModTTY ${LANG_FRENCH}  "Module de démonstration."
Section /o "MkModTTY" SecMkModTTY
  SetOutPath "$INSTDIR\plugins"
  File "${TOPBUILDDIR}/wininst/usr/lib/mkernel/mkmodtty-0/*"
  CreateShortCut "$DESKTOP\${APPNAME}-mod.lnk" "$INSTDIR\mkernel.exe" "mkmodtty-0"
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
    createShortCut "$SMPROGRAMS\$StartMenuFolder\${APPNAME}-mod.lnk" "$INSTDIR\mkernel.exe" "mkmodtty-0"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

LangString DESC_SecMkModGTK ${LANG_ENGLISH} "Sample module GTK."
LangString DESC_SecMkModGTK ${LANG_FRENCH}  "Module GTK de démonstration."
Section /o "MkModGTK" SecMkModGTK
  SetOutPath "$INSTDIR\plugins"
  File "${TOPBUILDDIR}/wininst/usr/lib/mkernel/mkmodgtk-0/*"
  CreateShortCut "$DESKTOP\${APPNAME}-gtk.lnk" "$INSTDIR\mkernel.exe" "mkmodgtk-0"
  !insertmacro MUI_STARTMENU_WRITE_BEGIN Application
    createShortCut "$SMPROGRAMS\$StartMenuFolder\${APPNAME}-gtk.lnk" "$INSTDIR\mkernel.exe" "mkmodgtk-0"
  !insertmacro MUI_STARTMENU_WRITE_END
SectionEnd

;--------------------------------
;Uninstaller Section

Section "Uninstall"
  ;Delete Files
  RMDir /r "$INSTDIR\*.*"
  RMDir "$INSTDIR"

  ;Delete Desktop Shortcuts
  Delete "$DESKTOP\${APPNAME}.lnk"
  Delete "$DESKTOP\${APPNAME}-aaa.lnk"
  Delete "$DESKTOP\${APPNAME}-mod.lnk"
  Delete "$DESKTOP\${APPNAME}-gtk.lnk"
  Delete "$DESKTOP\${APPNAME}-uninst.lnk"

  ;Remove Start Menu launcher
  !insertmacro MUI_STARTMENU_GETFOLDER Application $StartMenuFolder
  Delete "$SMPROGRAMS\$StartMenuFolder\${APPNAME}.lnk"
  Delete "$SMPROGRAMS\$StartMenuFolder\${APPNAME}-aaa.lnk"
  Delete "$SMPROGRAMS\$StartMenuFolder\${APPNAME}-mod.lnk"
  Delete "$SMPROGRAMS\$StartMenuFolder\${APPNAME}-gtk.lnk"
  RMDir "$SMPROGRAMS\$StartMenuFolder"

  ;Delete Uninstaller And Unistall Registry Entries
  DeleteRegKey HKCU "Software\${COMPANYNAME} - ${APPNAME}"
  DeleteRegKey HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} - ${APPNAME}"
  DeleteRegKey HKCU "Software\${COMPANYNAME} ${APPNAME}"
  DeleteRegKey HKCU "Software\Microsoft\Windows\CurrentVersion\Uninstall\${COMPANYNAME} ${APPNAME}"
SectionEnd

;--------------------------------
;Descriptions

;Assign language strings to sections
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SecCore} $(DESC_SecCore)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecMkModTTY} $(DESC_SecMkModTTY)
  !insertmacro MUI_DESCRIPTION_TEXT ${SecMkModGTK} $(DESC_SecMkModGTK)
!insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
;Functions

Function .onInit
  !insertmacro MUI_LANGDLL_DISPLAY
  SectionSetFlags ${SecCore} 17 # SF_SELECTED & SF_RO
FunctionEnd

Function un.onInit
  !insertmacro MUI_UNGETLANGUAGE
FunctionEnd
